<?php
class AttendanceConfController extends AppController
{   
	var $helpers = array('Html','Xml');
	var $uses=array('Poll','Group', 'Host','Configure', 'Validation','License','User',
		'Employee','Employeeaccount','Timecontrol','Workstatus','Grpattendconf','Hstattendance', 'Agentversion', 'Rlthstgrp');
	var $components = array("GenerateFiles");
	var $layout='attendance';
		
	function beforeFilter()
	{

	}
	
	function index($errorMessage = null)
	{
		$this->set("manage", $this->requestAction("/attendance_conf/manage", array("return"))) ;
    	$this->layout = "system";
    	$this->pageTitle = __('title',$return = true);  
	}
	
	function manage($depand=null,$tag=null){
        $errorMessage=array();
        $this->layout='ajax';
        $data= array();
		
        if($depand=='2'){//項目名変更
			var_dump($this->data);
			foreach($this->data['Workstatus'] as $s){
				
				echo $s;
			}
			$newname = eregi_replace("　", " ", $this->data['Workstatus']['content_'.$tag]);
            $newname = trim($newname, " ");
            if($this->Validation->maxLength($newname,200)){
                $updateaddition=Array(
                'Workstatus' => Array(
                'id' => $tag,
                'name' => $newname,
                )
                );
                $this->Workstatus->save($updateaddition);
				$this->Hstattendance->updateAll( array("1=1"), array('Hstattendance.newconf' => 1));

            }
            else{
                $errorMessage=array();
                if(!$this->Validation->maxLength($this->data['Workstatus']['content_'.$tag],200)){
                    if(@ !in_array('E-00300',$errorMessage['computer_list']))
                    $errorMessage['computer_list'][] = 'E-00300';
                }
            }
			$data= $this->Workstatus->findAll();
			
        }
		else if($depand=='4'){
            if($this->data['Grpattendconf']['notification']!="" 
				&& $this->Validation->numeric($this->data['Grpattendconf']['notification'])
				&& $this->data['Grpattendconf']['threshold']!="" 
				&& $this->Validation->numeric($this->data['Grpattendconf']['threshold']) )
			{
                $set_update=Array(
                'Grpattendconf' => Array(
                'id' => 1,
				'group_id' => 1,
                'notification' => $this->data['Grpattendconf']['notification'],
				'threshold' => $this->data['Grpattendconf']['threshold'],
                )
                );
                $this->Grpattendconf->save($set_update);
            }
            else{
                $errorMessage=array();
                if($this->data['Grpattendconf']['notification']=="" || $this->data['Grpattendconf']['threshold']==""){
                    if(@ !in_array('E-00100',$errorMessage['alert_depand']))
                    $errorMessage['alert_depand'][] = 'E-00100';
                }
                else if(!$this->Validation->numeric($this->data['Grpattendconf']['notification']) || !$this->Validation->numeric($this->data['Grpattendconf']['threshold'])){
                    if(@ !in_array('E-00600',$errorMessage['alert_depand']))
                    $errorMessage['alert_depand'][] = 'E-00600';
                }
            }
        }else
			$data= $this->Workstatus->findAll();


//var_dump($data);
        //$data= $this->Workstatus->findAll();
		$set= $this->Grpattendconf->find("Grpattendconf.id=1");//var_dump($set);
        $this->set('set', $set);
        $this->set('data', $data);
        $this->set('errorMessage', $errorMessage);
    }
	
	function addhost($name){
		$regist = date('Y-m-d H:i:s',time());
		$allupdatedate = Array('Host' => Array(
								'host_name' => $this->Lv->spec_char_dbm($name),
								'access_name' => $this->Lv->spec_char_dbm($name),
								'poll_id' => 0,
								'poll_type' => 0,
								'status' => 2,
								//'isagent' => 1,
								'regist_time' => $regist)
								);
		
		$this->Host->save($allupdatedate);
		$criteria[] = "Host.regist_time = '".$regist."'";
		$criteria[] = "Host.host_name = '".$this->Lv->spec_char_dbm($name)."'";
		$data= $this->Host->find($criteria);
		$addgroupdate=Array(
				'Rlthstgrp' => Array(
				'host_id' => $data['Host']['id'],
				'group_id' => 1,
				)
				);
		$this->Rlthstgrp->save($addgroupdate);
		return $data['Host']['id'];
	}
	
	//エージェントから通知
	function status($hostid = null, $status = null, $hostname = null)
    {	
		$this->layout="ajax";
		if($hostid == 0 && !is_null($hostname))
		{
			$host = $this->Host->findByHostName($this->Lv->spec_char_dbm($hostname));
			if(!empty($host))
				$hostid = $host['Host']['id'];
		}
		if($hostid == 0 && !is_null($hostname)){//登録
			$hostid = $this->addhost($hostname);
		}
		
		if(is_null($hostid) || is_null($status))
			echo "-1";
		elseif(!$this->Validation->numeric($hostid) || !$this->Validation->numeric($status) ){
			echo "-2";
		}
		else{
			$data = $this->Hstattendance->find(
				array("Hstattendance.host_id" => $this->Lv->spec_char_dbm($hostid),
						"Hstattendance.status" => $this->Lv->spec_char_dbm($status)));
			
			$set_update=Array(
                'Hstattendance' => Array(
                'host_id' => $hostid,
				'status' => $status,
                )
                );
			if(empty($data))
				$set_update['Hstattendance']['lasttime'] = "'".date("Y/m/d H:i:s")."'";
            $this->Hstattendance->save($set_update);
			echo "1";
		}
	}
	
	function check($hostid = null, $hostname = null)
    {	
		$this->layout="ajax";
		if($hostid == 0 && !is_null($hostname))
		{
			$host = $this->Host->findByHostName($this->Lv->spec_char_dbm($hostname));
			$hostid = $host['Host']['id'];
		}
		
		if(is_null($hostid))
			echo "0";
		else{
			$data = $this->Hstattendance->find(array("Hstattendance.host_id" => $this->Lv->spec_char_dbm($hostid)), "newconf");
			//var_dump($data);
			
			if(empty($data))
				echo "1";
			else{
				//現在の時刻を記録し、死活監視に利用する
				$set_update=Array(
					'Hstattendance' => Array(
						'host_id' => $hostid,
						'heartbeat' => date("Y/m/d H:i:s")
					)
				);
				$this->Hstattendance->save($set_update);
			
				echo $data['Hstattendance']['newconf'];
			}
		}
	}
	
	function getTimecontrol($groupid)
	{
		$default = $this->Timecontrol->find(array("group_id" => $groupid));
		if(empty($default))
		{
			$parent = $this->Group->group_father_id($groupid);
			if(!empty($parent))
				$default = $this->getTimecontrol($parent);
		}
		return $default;
	}
	//ステータスの一覧などの設定取得
    function get($hostid = null, $hostname = null)
    {	
		$this->layout="ajax";
		if($hostid == 0 && !is_null($hostname))
		{
			$host = $this->Host->findByHostName($this->Lv->spec_char_dbm($hostname));
			$hostid = $host['Host']['id'];
		}
		
		$criteria = array();
		$criteria[] = "1=1";
		$fields = array(
			'Workstatus.id',
			'Workstatus.autoreset',
			'Workstatus.name');

		$data = $this->Workstatus->findAll($criteria, $fields, "showorder asc");
		
		$set= $this->Grpattendconf->findAll("Grpattendconf.id=1", array("Grpattendconf.threshold","Grpattendconf.cycle"));
		
		////////////
		$asso = array(
			'Employeeaccount : employeeaccounts : LEFT' => array('Employeeaccount.employee_id = Employee.id'),
		) ;
			
		//取得項目
		$fields = array(
			'Employee.group_id'
		);
		$criteria = array();
		$criteria[]="Employeeaccount.host_id = ".$hostid;
		$empgrp = $this->Employee->findByAsso($criteria, $fields, null, null, null, $asso);
		//var_dump($timectrl);
		if(isset($empgrp[0])){
			$tmp = $this->getTimecontrol($empgrp[0]['Employee']['group_id']);
			$timectrl['Timecontrol']['start_day'] = $tmp['Timecontrol']['start_day'].":00";
		}else
			$timectrl['Timecontrol']['start_day'] = "00:00:00";
		
		
		$this->Hstattendance->updateAll( array("Hstattendance.host_id = $hostid"), array('Hstattendance.newconf' => 0));

		header("Content-Type: application/xml; charset=utf-8");
		$this->set(compact('data'));
		$this->set(compact('set'));
		$this->set(compact('timectrl'));
    }
	
	function installlog($host, $account)
	{
		//$this->layout='ajax';
		set_time_limit(0);

		if(is_null($host) || is_null($account))
			exit;
		$form_data = sprintf("%s,%s,%s\r\n", date("Y/m/d H:i:s"), $host, $account);
		$tmp =str_replace("\\","/", RESTORE_FILE_PATH);
		$file = $tmp . "/../Installlogs.txt";
		if(!file_exists($logdir)){

		}
		$txt = fopen($file,'a'); 
		if(!$txt)
			exit;
		flock($txt, LOCK_EX);
		fwrite($txt,$form_data); 
		fclose($txt); 
		echo 1;
		exit;
	}
	
	//バージョン情報を通知
    function version($hostid,$version,$hostname=null)
    {
		$this->layout="ajax";
		if($hostid == 0 && !is_null($hostname))
		{
			$host = $this->Host->findByHostName($this->Lv->spec_char_dbm($hostname));
			$hostid = $host['Host']['id'];
		}
		
		if(is_null($hostid))
			echo "-1";
		else if(!$this->Validation->numeric($hostid)){
			echo "-2";
		}
			
		$agent = array(
		'Agentversion' => array(
				'host_id' => $hostid,
				'lasttime' => date("Y/m/d H:i:s"),
				'version' => $version
			)
		);
		$this->Agentversion->save($agent);			
		
		echo "ok";
		exit;
    }
}
?>